# Source for file Email.php

Documentation is available at Email.php

1. <?php
2. /*
3. * $Id: Email.php 1444 2007-05-23 09:55:32Z romanb $
4. *
5. * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6. * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7. * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8. * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9. * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10. * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11. * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12. * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13. * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14. * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15. * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16. *
17. * This software consists of voluntary contributions made by many individuals
18. * and is licensed under the LGPL. For more information, see
19. * <http://www.phpdoctrine.com>.
20. */
22. /**
23. * Doctrine_Validator_Email
24. *
25. * @package Doctrine
26. * @category Object Relational Mapping
27. * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
28. * @link www.phpdoctrine.com
29. * @since 1.0
30. * @version $Revision: 1444 $
31. * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
32. */
33. class Doctrine_Validator_Email
34. {
35. /**
36. * @link http://iamcal.com/publish/articles/php/parsing_email/pdf/
37. * @param Doctrine_Record $record
38. * @param string $key
39. * @param mixed $value
40. * @param string $args
41. * @return boolean
42. */
43. public function validate(Doctrine_Record $record, $key, $value, $args)
44. {
45. if (empty($value)) {
46. return true;
47. }
48. if (isset($args[0])) {
49. $parts = explode("@", $value);
50. if (isset($parts[1]) && function_exists("checkdnsrr")) {
51. if ( ! checkdnsrr($parts[1], "MX")) {
52. return false;
53. }
54. }
55. }
57. $qtext = '[^\\x0d\\x22\\x5c\\x80-\\xff]';
58. $dtext = '[^\\x0d\\x5b-\\x5d\\x80-\\xff]';
59. $atom = '[^\\x00-\\x20\\x22\\x28\\x29\\x2c\\x2e\\x3a-\\x3c\\x3e\\x40\\x5b-\\x5d\\x7f-\\xff]+';
60. $quoted_pair = '\\x5c[\\x00-\\x7f]';
61. $domain_literal = "\\x5b($dtext|$quoted_pair)*\\x5d";
62. $quoted_string = "\\x22($qtext|$quoted_pair)*\\x22";
63. $domain_ref = $atom;
64. $sub_domain = "($domain_ref|$domain_literal)";
65. $word = "($atom|$quoted_string)";
66. $domain = "$sub_domain(\\x2e$sub_domain)+";
67. /*
68. following psudocode to allow strict checking - ask pookey about this if you're puzzled
70. if ($this->getValidationOption('strict_checking') == true) {
71. $domain = "$sub_domain(\\x2e$sub_domain)*";
72. }
73. */
74. $local_part = "$word(\\x2e$word)*";
75. $addr_spec = "$local_part\\x40$domain";
77. return (bool)preg_match("!^$addr_spec$!D", $value);
78. }
80. }